#include "stm32f10x.h"
#include "delay.h"
#include "HAL_uart.h"
#include "stdio.h"
#include "stm32f10x_it.h"
#include "project_config.h"
#include "LLCC68_example_send.h"
#include "LLCC68_example_recive.h"

/*
wiring setting
spi bus:
	LoRa modules		  STM32
	NSS_PIN				    PA4
	MOSI_PIN      		PA7
	MISO_PIN     		  PA6
	SCK_PIN       		PA5
	RESET_PIN    		  PB1
	DIO1_PIN      		PB11
	DIO4_BUSY_PIN     PA0

UART:
	USB to TTL			STM32
	Tx					    PA_9
	Rx					    PA_10
*/


//Ӳʼ
void SysInit(void){
	GPIO_InitTypeDef  GPIO_InitStructure;
	
	NVIC_PriorityGroupConfig(NVIC_PriorityGroup_4);	//NVIC(жȼ),ע:ֻһ,úҪ޸,ֺܶ ֱ4,0~15ȼ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_AFIO, ENABLE);	    //JTAGΪGPIOҪʹ RCC_APB2Periph_AFIO ʱ
	GPIO_PinRemapConfig(GPIO_Remap_SWJ_JTAGDisable,ENABLE);	//رJTAG(Ҫ RCC_APB2Periph_AFIO ʱ)

	//ledָʾ
	RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB, ENABLE);
	GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
	GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP; 	 //
	GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;	 //IOٶΪ50MHz
	GPIO_Init(GPIOB, &GPIO_InitStructure);
	GPIO_SetBits(GPIOB,GPIO_Pin_12); 			 //PB.12 
	
	HALUart1Init();
	SysTick_Config(SystemCoreClock/1000);
}

int main(void){
	SysInit();	//Ӳʼ
	
	printf("SysInit OKversion:%s\r\n",SOFT_VERSION);

	//demoһֻܴһdemodemo󽫽ѭ᷵
	ExampleLLCC68ReciveDemo();	//ѭdemo
	
//	ExampleLLCC68SendDemo();	//ʱdemo
	
	//demoִв
	while(1){
		printf("systick=%d\r\n",Get_SysTick());
		GPIO_ResetBits(GPIOB,GPIO_Pin_12);
		delay_ms(500);
		GPIO_SetBits(GPIOB,GPIO_Pin_12);
		delay_ms(500);
	}
}
